
<template>
    <v-card flat>
        <v-card-title class="pr-2">
            Change Results
            <v-spacer></v-spacer>
            {{ successfulCommits.length }} Success / {{ errorCommits.length }} Errors
            <v-spacer></v-spacer>
            <v-switch dense hide-details inset class="ma-0 pa-1 pr-2" label="Show Only Errors" v-model="showOnlyErrors">
            </v-switch>
        </v-card-title>
        <v-data-table id="resultTable" :items="resultTableDataFiltered" :headers="resultTableHeaders"
            :footer-props="{'items-per-page-options': [20, 50, 100, -1]}" dense no-data-text="No changes"
            :items-per-page="20">
            <template v-slot:item.complianceFramework="{ item }">
                <div v-if="item.hasComplianceFramework">
                    <v-icon small :color="item.complianceFramework.color">mdi-circle</v-icon> {{
                    item.complianceFramework.name }}
                </div>
                <div v-else>
                    <v-icon small color="grey">mdi-circle-outline</v-icon> No Framework
                </div>
            </template>
            <template v-slot:item.newComplianceFramework="{ item }">
                <div v-if="item.newComplianceFramework != null">
                    <v-icon small :color="item.newComplianceFramework.color">mdi-circle</v-icon> {{
                    item.newComplianceFramework.name }}
                </div>
                <div v-else>
                    <v-icon small color="grey">mdi-circle-outline</v-icon> No Framework
                </div>
            </template>
            <template v-slot:item.result="{ item }">
                <div v-if="item.errors.length === 0">
                    <v-icon color="green">mdi-check-circle-outline</v-icon>
                </div>
                <div v-else>
                    <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs}">
                            <v-icon color="red" v-bind="attrs" v-on="on">mdi-alert-circle-outline</v-icon>
                        </template>
                        <span v-for="error in item.errors" :key="error" style="display: block">{{ error }}</span>
                    </v-tooltip>
                </div>
            </template>
            <template v-slot:item.webUrl="{ item }">
                <td>
                    <v-btn x-small icon :href="item.webUrl" target="_blank">
                        <v-icon color="primary">mdi-open-in-new</v-icon>
                    </v-btn>
                </td>
            </template>
        </v-data-table>
        <v-card-actions>
            <v-spacer/>
            <v-btn color="primary" depressed small @click.native="downloadResults">Download Results</v-btn>
          </v-card-actions>
    </v-card>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'
import * as Excel from 'xlsx'

@Component
export default class ImportProjectAssignments extends Vue {
    @Prop({ default: [] })
    results!: any[]

    showOnlyErrors = false

    resultTableHeaders = [
      {
        text: 'Project Name',
        value: 'name',
        sortable: true
      },
      {
        text: 'Path',
        value: 'path'
      },
      {
        text: 'Old Framework',
        value: 'complianceFramework',
        sortable: true
      },
      {
        text: 'New Framework',
        value: 'newComplianceFramework'
      },
      {
        text: 'Result',
        value: 'result'
      },
      {
        text: '',
        value: 'webUrl',
        sortable: false
      }
    ]

    get resultTableData (): any {
      return this.results.map(result => {
        return {
          name: result.project.name,
          path: result.project.path,
          complianceFramework: result.project.complianceFramework,
          hasComplianceFramework: result.project.hasComplianceFramework,
          newComplianceFramework: result.project.newComplianceFramework,
          errors: result.errors,
          webUrl: result.project.webUrl
        }
      })
    }

    get successfulCommits (): any {
      return this.resultTableData.filter((entry: any) => entry.errors?.length === 0 ?? true)
    }

    get errorCommits (): any {
      return this.resultTableData.filter((entry: any) => entry.errors?.length > 0 ?? false)
    }

    get resultTableDataFiltered (): any {
      if (this.showOnlyErrors) {
        return this.errorCommits
      }
      return this.resultTableData
    }

    downloadResults (): void {
      const workbook = Excel.utils.book_new()

      Excel.utils.book_append_sheet(workbook, this.buildResultSheet(), 'Import Results')
      Excel.utils.book_append_sheet(workbook, this.buildUndoSheet(), 'Undo Sheet')

      var fileName = 'Import Result.xlsx'

      // eslint-disable-next-line security/detect-non-literal-fs-filename
      Excel.writeFile(workbook, fileName)
    }

    buildResultSheet (): any {
      const header = [['ID', 'Name', 'Path', 'Old Compliance Framework', 'New Compliance Framework', 'Import Result', 'Error Message', 'Project URL']]
      const output: any[] = []

      this.results.forEach((result: any) => {
        const project = result.project
        const sheetEntry: any = {
          id: project.id,
          name: project.name,
          path: project.path,
          oldCmplianceFrameworkName: project.complianceFramework?.name ?? '',
          newComplianceFrameworkName: project.newComplianceFramework?.name ?? '',
          result: result.isSuccess ? 'Success' : 'Failed',
          errorMessage: result.isSuccess ? '' : result.errors.join(';'),
          url: project.webUrl
        }

        output.push(sheetEntry)
      })

      const sheet = Excel.utils.json_to_sheet([])
      Excel.utils.sheet_add_aoa(sheet, header)
      Excel.utils.sheet_add_json(sheet, output, { origin: 'A2', skipHeader: true })
      sheet['!cols'] = [
        { width: 10 },
        { width: 30 },
        { width: 40 },
        { width: 30 },
        { width: 30 },
        { width: 20 },
        { width: 40 },
        { width: 80 }
      ]

      return sheet
    }

    buildUndoSheet (): any {
      const header = [['ID', 'Name', 'Path', 'Compliance Framework', 'URL']]
      const output: any[] = []

      this.results.forEach((result: any) => {
        const project = result.project
        const sheetEntry: any = {
          id: project.id,
          name: project.name,
          path: project.path,
          complianceFrameworkName: project.hasComplianceFramework ? project.complianceFramework.name : '',
          url: project.webUrl
        }

        output.push(sheetEntry)
      })

      const sheet = Excel.utils.json_to_sheet([])
      Excel.utils.sheet_add_aoa(sheet, header)
      Excel.utils.sheet_add_json(sheet, output, { origin: 'A2', skipHeader: true })
      sheet['!cols'] = [
        { width: 10 },
        { width: 30 },
        { width: 40 },
        { width: 30 },
        { width: 80 }
      ]

      return sheet
    }
}
</script>
